#ifndef __MELODY_BP_H__
#define __MELODY_BP_H__
#include <Energia.h>

static const uint16_t bufferLength = 4000;
static const uint8_t sbp_pin = A1;
static const uint8_t wbp_pin = A2;

enum eComState
{
    IDLE = 0,
    ONLINE,
    MEASURE,
    RESET
};

class CMelodyBP
{
    private:
        float m_SBPbuffer[bufferLength];                 //袖套压缓存
        float m_WBPbuffer[bufferLength];                 //波动缓存
        uint16_t m_buffertindex;                         //缓存索引
        bool m_start;                                    //开始存储数据标志
        bool m_rxComplete;

        float transfer(uint16_t sample);                 //AD采样值转换成血压 mmHg

        float readStaticBP(void);
        float readWaveBP(void);
        uint16_t readBloodPressure(void);    
      
    public:
        CMelodyBP(void);
        void begin(void);
        bool measurement(void);
        void transmitBoolPressure(HardwareSerial &h_serial);  //发送数据
        char* receiveComPacket(HardwareSerial &h_serial,char* p_Combuffer,uint8_t Comlength);
        bool available(void);
        eComState handleComPacket(HardwareSerial &h_serial,char* p_Combuffer);

        void clear(void);

};

extern CMelodyBP MelodyBP;
#endif