#include <stdint.h>
#include <stdbool.h>
#include "Melody_BP.h"

const uint8_t rxLength = 10;
char rxBuffer[rxLength] = {0};
eComState runState = IDLE;

void setup()
{
  // put your setup code here, to run once:
  Serial.begin(115200);
  MelodyBP.begin();  
}

void loop()
{
  // put your main code here, to run repeatedly:
  //if(MelodyBP.available() && (runState != MEASURE))
  if(MelodyBP.available())
  {
    runState = MelodyBP.handleComPacket(Serial,rxBuffer);
    memset(rxBuffer,0,rxLength);
  }
  switch(runState)
  {
    case IDLE:
    break;
    case ONLINE:
        //do something
       
        runState = IDLE;
    break;
    case MEASURE:
      if(MelodyBP.measurement())
      {           
        MelodyBP.transmitBoolPressure(Serial);
        runState = IDLE;
      }
    break;
    case RESET:
      MelodyBP.clear();
      runState = IDLE;
    break;
    default:
    break;
  }
}

void serialEvent()
{
  MelodyBP.receiveComPacket(Serial,rxBuffer,rxLength);
}
