#ifndef __MELODY_HDC1080_H__
#define __MELODY_HDC1080_H__

#define HDC_ADDRESS                 0x40               //address

#define HDCREG_TEMPERATURE         0x00                //Temperature measurement output
#define HDCREG_HUMIDITY            0x01                //Relative Humidity measurement output
#define HDCREG_CONFIGURATION       0x02                //configuration and status
#define HDCREG_SERIALID_FRIST      0xFB                //First 2 bytes of the serial of the part
#define HDCREG_SERIALID_MID        0xFC                //Mid 2 bytes of the serial of the part
#define HDCREG_SERIALID_LAST       0xFD                //Last 2 bytes of the serial of the part
#define HDCREG_MANUFACTURERID      0xFE                //ID of TI
#define HDCREG_DEVICEID            0xFF                //ID of the device

#define HDC_CONFIGURATION           0x0000              //Normal Operation,Temperature or Humidity is acquired
                                                        //Measurement Resolution:14bit

class CMelodyHDC1080
{
    private:
        uint16_t read(uint8_t regaddress);
        void write(uint8_t regaddress,uint8_t *pdata,uint8_t length);
    public:
        CMelodyHDC1080();
        void begin();
        float getTemperature();
        float getHumidity();
        uint16_t getManufacturerID();
        uint16_t getDeviceID();
        uint16_t* getSerialID(uint16_t *pdata,uint8_t length);
};

extern CMelodyHDC1080 MelodyHDC1080;
#endif /*__MELODY_HDC1080_H__*/