#ifndef __MELODY_LIBATTERY_H__
#define __MELODY_LIBATTERY_H__

#define BQADDRESS                                  0x55                  //地址

//------Standard Commands:每个standar command有两个command code,X_LSB和X_MSB区分-----------------//
#define BQSTDCMD_CONTROL_LSB                       0x00                  //Contorl()
#define BQSTDCMD_CONTROL_MSB                       0x01                  //Contorl()
#define BQSTDCMD_ATRATE_LSB                        0x02                  //AtRate()   
#define BQSTDCMD_ATRATE_MSB                        0x03                  //AtRate()  
#define BQSTDCMD_USOC_LSB                          0x04                  //UnfilteredSOC()
#define BQSTDCMD_USOC_MSB                          0x05                  //UnfilteredSOC()
#define BQSTDCMD_TEMPERATURE_LSB                   0x06                  //Temperature()
#define BQSTDCMD_TEMPERATURE_MSB                   0x07                  //Temperature()
#define BQSTDCMD_VOLTAGE_LSB                       0x08                  //Voltage()
#define BQSTDCMD_VOLTAGE_MSB                       0x09                  //Voltage()
#define BQSTDCMD_FLAGS_LSB                         0x0A                  //Flags()   
#define BQSTDCMD_FLAGS_MSB                         0x0B                  //Flags()   
#define BQSTDCMD_NAVAILCAPACITY_LSB                0x0C                  //NomAvailableCapacity()
#define BQSTDCMD_NAVAILCAPACITY_MSB                0x0D                  //NomAvailableCapacity()
#define BQSTDCMD_FAVAILCAPACITY_LSB                0x0E                  //FullAvailableCapacity()
#define BQSTDCMD_FAVAILCAPACITY_MSB                0x0F                  //FullAvailableCapacity()
#define BQSTDCMD_REMAININGCAPACITY_LSB             0x10                  //RemainingCapacity()
#define BQSTDCMD_REMAININGCAPACITY_MSB             0x11                  //RemainingCapacity()
#define BQSTDCMD_FCHARGECAPACITY_LSB               0x12                  //FullChargeCapacity()
#define BQSTDCMD_FCHARGECAPACITY_MSB               0x13                  //FullChargeCapacity()
#define BQSTDCMD_AVERAGECURRENT_LSB                0x14                  //AverageCurrent()
#define BQSTDCMD_AVERAGECURRENT_MSB                0x15                  //AverageCurrent()
#define BQSTDCMD_TIMEEMPTY_LSB                     0x16                  //TimeToEmpty()
#define BQSTDCMD_TIMEEMPTY_MSB                     0x17                  //TimeToEmpty()
#define BQSTDCMD_FCCF_LSB                          0x18                  //FullChargeCapacityfiltered()
#define BQSTDCMD_FCCF_MSB                          0x19                  //FullChargeCapacityfiltered()
#define BQSTDCMD_SAFETYSTATUS_LSB                  0x1A                  //SafetyStatus()
#define BQSTDCMD_SAFETYSTATUS_MSB                  0x1B                  //SafetyStatus()
#define BQSTDCMD_FCCU_LSB                          0x1C                  //FullChargeCapacityUnfiltered()
#define BQSTDCMD_FCCU_MSB                          0x1D                  //FullChargeCapacityUnfiltered()
#define BQSTDCMD_IMAX_LSB                          0x1E                  //Imax()
#define BQSTDCMD_IMAX_MSB                          0x1F                  //Imax()
#define BQSTDCMD_RCU_LSB                           0x20                  //RemainingCapacityUnfiltered()
#define BQSTDCMD_RCU_MSB                           0x21                  //RemainingCapacityUnfiltered()
#define BQSTDCMD_RCF_LSB                           0x22                  //RemainingCapacityFiltered()         
#define BQSTDCMD_RCF_MSB                           0x23                  //RemainingCapacityFiltered()   
#define BQSTDCMD_BSS_LSB                           0x24                  //BTPSOC1Set()
#define BQSTDCMD_BSS_MSB                           0x25                  //BTPSOC1Set()
#define BQSTDCMD_BSC_LSB                           0x26                  //BTPSOC1Clear()
#define BQSTDCMD_BSC_MSB                           0x27                  //BTPSOC1Clear()
#define BQSTDCMD_INTERNALTEMPERATURE_LSB           0x28                  //InternalTemperature()
#define BQSTDCMD_INTERNALTEMPERATURE_MSB           0x29                  //InternalTemperature()
#define BQSTDCMD_CYCLEOUNT_LSB                     0x2A                  //CycleCount()
#define BQSTDCMD_CYCLEOUNT_MSB                     0x2B                  //CycleCount()
#define BQSTDCMD_STATEHARGE_LSB                    0x2C                  //StateofCharge()
#define BQSTDCMD_STATEHARGE_MSB                    0x2D                  //StateofCharge()
#define BQSTDCMD_STATEHEALTH_LSB                   0x2E                  //StateofHealth()
#define BQSTDCMD_STATEHEALTH_MSB                   0x2F                  //StateofHealth()
#define BQSTDCMD_CHARGINGVOLTAGE_LSB               0x30                  //ChargingVoltage()
#define BQSTDCMD_CHARGINGVOLTAGE_MSB               0x31                  //ChargingVoltage()
#define BQSTDCMD_CHARGINGCURRENT_LSB               0x32                  //ChargingCurrent()
#define BQSTDCMD_CHARGINGCURRENT_MSB               0x33                  //ChargingCurrent()
#define BQSTDCMD_PASSEDCHARGE_LSB                  0x34                  //PassedCharge
#define BQSTDCMD_PASSEDCHARGE_MSB                  0x35                  //PassedCharge
#define BQSTDCMD_DOD_LSB                           0x36                  //DOD0()
#define BQSTDCMD_DOD_MSB                           0x37                  //DOD0()
#define BQSTDCMD_SDC_LSB                           0x38                  //SelfDischargeCurrent();
#define BQSTDCMD_SDC_MSB                           0x39                  //SelfDischargeCurrent();

//-------Contorl() Subcommands：均为两个字节的command code-----------------------------//
#define BQSUBCMD_CONTROLSTATUS                 0x0000                  //Reports the status of DF Checksum,Impedance Track,etc
#define BQSUBCMD_DEVICETYPE                    0x0001                  //Reports the device type of 0x0541
#define BQSUBCMD_FWVERSION                     0x0002                  //Reports the firmware version on the device type
#define BQSUBCMD_HWVERSION                     0x0003                  //Reports the hardware version on the device type
#define BQSUBCMD_RESETDATA                     0x0005                  //Returns reset data
#define BQSUBCMD_PREVMACWRITE                  0x0007                  //Returns previous Control subcommand code
#define BQSUBCMD_CHEMID                        0x0008                  //Reports the chemical id
#define BQSUBCMD_BOARDOFFSET                   0x0009                  //Forces the device to measure and store the board offset
#define BQSUBCMD_CCOFFSET                      0x000A                  //Forces the device to measure the CC offset
#define BQSUBCMD_EFVERSION                     0x000C                  //Reports the data flash version of the device
#define BQSUBCMD_SETFULLSLEEP                  0x0010                  //Sets the CONTROL_STATUS[FULLSLEEP]bit to 1
#define BQSUBCMD_SETHIBERNATE                  0x0011                  //Forces CONTROL_STATUS[HIBERNATE]bit to 1
#define BQSUBCMD_CLEARHIBERNATE                0x0012                  //Forces CONTROL_STATUS[HIBERNATE]bit to 0
#define BQSUBCMD_SETSHUTDOWN                   0x0013                  //Sets the CONTROL_STATUS[SHUTDWN]bit to 1
#define BQSUBCMD_CLEARSHUTDOWN                 0x0014                  //Clears the CONTROL_STATUS[SHUTDWN]bit to 0
#define BQSUBCMD_SETHDQINTEN                   0x0015                  //Forces CONTROL_STATUS[HDQIntEn]to 1
#define BQSUBCMD_CLEARHDQINTEN                 0x0016                  //Forces CONTROL_STATUS[HDQIntEn]to 0
#define BQSUBCMD_SCCHKSUM                      0x0017                  //Calculates chemistry checksum
#define BQSUBCMD_ADCHKSUM                      0x0018                  //Reports checksum for all data flash excluding device
                                                                       //specific variables
#define BQSUBCMD_SDCHKSUM                      0x0019                  //Reports checksum for static data flash excluding device
                                                                       //specific variables
#define BQSUBCMD_SYNCSMOOTH                    0x001E                  //Synchronizes RemCapSmooth() and FCCSmooth() with
                                                                       //RemCapTrue() and FCCTrue()
#define BQSUBCMD_SEALED                        0x0020                  //Places the fuel gauge in SEALED access mode
#define BQSUBCMD_ITENABLE                      0x0021                  //Enables the Impedance Track algorithm
#define BQSUBCMD_IMAXINTCLEAR                  0x0023                  //Clears an Imax interrupt that is currently asserted
                                                                       //on the (SE or HDQ) pin
#define BQSUBCMD_CALENABLE                     0x002D                  //Toggle CALIBRATION mode
#define BQSUBCMD_RESET                         0x0041                  //Forces a full reset of the fuel gauge
#define BQSUBCMD_EXITCAL                       0x0080                  //Exit CALIBRATION mode
#define BQSUBCMD_ENTERCAL                      0x0081                  //Enter CALIBRATION mode
#define BQSUBCMD_OFFSETCAL                     0x0082                  //Reports internal CC offset in CALIBRATION mode

//----------------Extended Commands：command code个数不定，多个code的以X_START开头，X_END结束---------------------//
#define BQEXTCMD_PACKCONFIG_START              0x3A                    //PackConfiguration()
#define BQEXTCMD_PACKCONFIG_END                0x3B                    //PackConfiguration()
#define BQEXTCMD_DESIGNCAPACITY_START          0x3C                    //DesignCapacity()
#define BQEXTCMD_DESIGNCAPACITY_END            0x3D                    //DesignCapacity()
#define BQEXTCMD_DFC                           0x3E                    //DataFlashClass()
#define BQEXTCMD_DFB                           0x3F                    //DataFlashBlock()
#define BQEXTCMD_BDA_START                     0x40                    //BlockData()/Authenticate() start
#define BQEXTCMD_BDA_END                       0x53                    //BlockData()/Authenticate() end 
#define BQEXTCMD_BDACHECKSUM                   0x54                    //BlockData()/AuthenticateCheckSum()
#define BQEXTCMD_BD_START                      0x55                    //BlockData() Start
#define BQEXTCMD_BD_END                        0x5F                    //BlockData() End
#define BQEXTCMD_BDCHECKSUM                    0x60                    //BlockDataCheckSum()
#define BQEXTCMD_BDCONTROL                     0x61                    //BlockDataControl()
#define BQEXTCMD_DODATEOC_START                0x62                    //DODatEOC()
#define BQEXTCMD_DODATEOC_END                  0x63                    //DODatEOC()
#define BQEXTCMD_QSTART_START                  0x64                    //Qstart()
#define BQEXTCMD_QSTART_END                    0x65                    //Qstart()
#define BQEXTCMD_FASTQMAX_START                0x66                    //FastQmax()
#define BQEXTCMD_FASTQMAX_END                  0x67                    //FastQmax()

//----Access KEY------------------------//
#define BQKEY_UNSEALED                        0x36720414              //Sealed to Unsealed
#define BQKEY_FULL                            0xFFFFFFFF              //Unsealed to Full

class CMelodyLiBattery
{
    private:
        void write(uint8_t cmd,uint8_t data);
        void write(uint8_t cmd,uint16_t data);
        void write(uint8_t cmd,uint8_t *pdata,uint8_t length);
        uint16_t read(uint8_t cmd);
        uint8_t read(uint8_t cmd,uint8_t *pdata,uint8_t length);

    public:
        void begin(void);
        float getTemperature(void);
        float getInternalTemperature(void);
        uint16_t getVoltage(void);
        int16_t getAverageCurrent(void);
        uint16_t getRemainingCapacity(void);
        uint8_t getStateOfCharge(void);

};

extern CMelodyLiBattery MelodyLiBattery;
#endif /*__MELODY_LIBATTERY_H__*/