#ifndef __MELODY_OPT3001_H__
#define __MELODY_OPT3001_H__

#define OPTADDRESS                  0x44

#define OPTREG_RESULT               0x00
#define OPTREG_COMFIGURATION        0x01
#define OPTREG_LOWLIMIT             0x02
#define OPTREG_HIGHLIMIT            0x03
#define OPTREG_MANUFACTURERID       0x7E
#define OPTREG_DEVICEID             0x7F

#define OPTVALUE_CONFIGURATION      0xC410

class CMelodyOPT3001
{
    private:
        void write(uint8_t regAddress,uint16_t data);
        uint16_t read(uint8_t regAddress);
        
    public:
        void begin(void);
        uint16_t getManufacturerID(void);
        uint16_t getDeviceID(void);
        float getLux(void);
};

extern CMelodyOPT3001 MelodyOPT3001;


#endif /*__MELODY_OPT3001_H__*/