#ifndef __MELODY_SIMPLEHTML_H__
#define __MELODY_SIMPLEHTML_H__



#ifdef __cplusplus
extern "C"
{
#endif

enum e_MelodyModule
{
    MELODYLED,
    MELODYHDC1080,
    MELODYLDC1000,
    MELODYLMT84,
    MELODYADXL345,
    MELODYSTEPMOTOR
};

extern void beginServer(WiFiServer &server,char *ssid,char *pwd);
extern void printLEDhtml(WiFiClient &client,uint8_t bright);
extern void handleLEDRequest(WiFiServer &server,WiFiClient &client);

extern void printHDC1080html(WiFiClient &client,uint16_t manufID,uint16_t deviceID,float temperature,float humidity);
extern void handleHDC1080Request(WiFiServer &server,WiFiClient &client);

extern void printLDC1000html(WiFiClient &client,uint16_t deviceID,uint16_t proximity,float inductance);
extern void handleLDC1000Request(WiFiServer &server,WiFiClient &client);

extern void printLMT84html(WiFiClient &client,float temperature);
extern void handleLMT84Request(WiFiServer &server,WiFiClient &client);

extern void printADXL345html(WiFiClient &client,uint16_t DeviceID,int16_t x,int16_t y,int16_t z);
extern void handleADXL345Request(WiFiServer &server,WiFiClient &client);

extern void printStepMotorhtml(WiFiClient &client,bool direction,uint16_t speed);
extern void handleStepMotorRequest(WiFiServer &server,WiFiClient &client);

extern void printOPT3001html(WiFiClient &client,uint16_t manufID,uint16_t deviceID,float lux);
extern void handleOPT3001Request(WiFiServer &server,WiFiClient &client);

//extern void handleHtmlRequest(WiFiServer &server,WiFiClient client,e_MelodyModule module);
#ifdef __cplusplus
}
#endif
#endif //__MELODY_SIMPLEHTML_H__