#ifndef __MELODY_STEPMOTOR_H__
#define __MELODY_STEPMOTOR_H__

#define MAXSPEED            10
#define MINSPEED            1

#define MAXSTEPS            20

#define PIN_AIN1            40
#define PIN_AIN2            39
#define PIN_BIN1            37
#define PIN_BIN2            38

class CMelodyStepMotor
{
    private:
        int8_t m_step;
        uint8_t m_speed;
        bool m_direction;

        void timerInit(void);
    public:
        void begin();
        void begin(uint8_t speed);
        void begin(uint8_t speed,bool direction);
        void begin(uint8_t speed,bool direction,uint8_t step);
        void changeSpeed(uint8_t speed);
        uint8_t getSpeed(void);
        void changeDirection(bool direction);
        bool getDirection(void);
        uint8_t getSteps(void);
        void setBeginStep(uint8_t step);

        void InterruptHandler(void);
};

extern CMelodyStepMotor MelodyStepMotor;

extern "C" void timerInterruptHandler(void);
#endif //__MELODY_STEPMOTOR_H__